/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package observerbriof;

import java.util.ArrayList;

/**
 *
 * @author patrickbelem
 */
public class BankSlipSubject implements Subject{
       
    private ArrayList<Observer> observers;
    protected BankSlip bankSlip;
    
    public BankSlipSubject() {
        observers = new ArrayList<Observer>();
    }
    
   public void setState(BankSlip bankSlip) { //setMeasurements
       this.bankSlip = bankSlip;
       notifyObservers();
    }
     
    @Override
    public void attach(Observer observer) {
        observers.add(observer);
    }
    
    @Override
     public void detach(Observer observer) {
       int i = observers.indexOf(observer);
		if (i >= 0) {
			observers.remove(i);
		}
    }
    @Override
       public void notifyObservers() {
       for (int i = 0; i < observers.size(); i++) {
			Observer observer = (Observer)observers.get(i);
			observer.update(bankSlip);
                        
		}
    }

    
}
